<?

class C_UserDef
{
	var $Vars;
	var $exists;
	
	function C_UserDef($Base,$UID)
	{
		$this->exists = 0;
		$file = fopen($Base,'r') or die ("Could not open file $filename");
		while ($line = fgets($file,10240))
		{
			$line=trim(strcmp(substr($line,0,1),'#')==0?'':strtok($line,'#'));
			if ($line)
			{
				list($key,$value) = split(' ',$line,2);
				$key = trim(strtolower($key));
				$value = trim($value);
				if (strcmp($key,'user')==0):
					if ($loaduser = (strcmp($UID,$value)==0)):
						$this->Vars['uid'] = $value;
						$this->exists = 1;
					endif;
				elseif($loaduser):
					$i = '';
					while (@$this->Vars[$key.$i]) $i++;
					$this->Vars[$key.$i] = $value;
				endif;
			}
		}
		fclose($file);
	}
}

#class C_Users
#{
#	var $Vals;
#
#	function C_Users($filename)
#	{
#		$file = fopen($filename,'r') or die ("Could not open file $filename");
#		while ($line = fgets($file,10240))
#		{
#			$line=trim(strcmp(substr($line,0,1),'#')==0?'':strtok($line,'#'));
#			if ($line)
#			{
#				$this->Vals[] = new C_UserDef($line);
#			}
#		}
#		fclose($file);
#	}
#
#	function Valid_User($name,$password)
#	{
#		if (!$this->Vals) {return 0;}
#		foreach ($this->Vals as $user)
#		{ 
#			if ((strcmp($user->name,$name)==0) && (strcmp($password,$user->pwd)==0)) { return 1; }
#		}
#		return 0;
#	}
#
#	function FindUserNum($name)
#	{
#		if ($this->Vals):
#		for ($i=0;$this->Vals[$i];$i++)
#		{
#			if (strcasecmp($this->Vals[$i]->name,$name)==0):
#				return $i;
#			endif;
#		}
#		endif;
#		return -1;
#	}
#
#}

class C_Links
{
	var $LinkDef;
	var $Vals;
	var $Curr_ms;
	
	function C_Links($filename)
	{
		$linknew = 0;
		$file = fopen($filename,'r') or die ("Could not open file $filename");
		while ($line = fgets($file,10240))
		{
			$line=trim(strcmp(substr($line,0,1),'#')==0?'':strtok($line,'#'));
			if ($line)
			{
				@list($key,$value) = split(' ',$line,2);
				$key = trim(strtolower($key));
				$value = trim($value);
				if (strcmp($key,'linkdefaults')==0):
					$this->Addlink($linknew);
					$linknew=0;
				elseif (strcmp($key,'link')==0):
					$this->Addlink($linknew);
					$linknew=1;
					$this->Curr_ms['sysop']=$value;
				else:
					$i = '';
					while (@$this->Curr_ms[$key.$i]) $i++;
					$this->Curr_ms[$key.$i] = $value;
				endif;
			}
		}
		$this->AddLink($linknew);
		fclose($file);
		unset($this->Curr_ms);
	}

	function AddLink($linknew)
	{
		if ($this->Curr_ms)
		{
			if ($linknew):
				if ($this->LinkDef)
				{
				reset($this->LinkDef);
				while (list($key,$value)=each($this->LinkDef)):
					if (!$this->Curr_ms[$key])
					{ $this->Curr_ms[$key]=$value; }
				endwhile;
				};
				$this->Vals[$this->Curr_ms['aka']]=$this->Curr_ms;
			else:
				reset($this->Curr_ms);
				while (list($key,$value)=each($this->Curr_ms)):
					$this->LinkDef[$key]=$value;
				endwhile;
			endif;
		}
		$this->Curr_ms = array();
	}
}

class C_AreaDef
{
	var $EchoTag;
	var $Path;
	var $Status;
	var $Links;
	var $Options;

	function C_AreaDef($line)
	{
	$vkh = 0;
	$line2 = '';
	if ($line):
		for ($i=0; $i<strlen($line); $i++):
			$c = substr($line,$i,1);
			if (strcmp($c,'"')==0):
		       		$vkh++;
			elseif ((strcmp(substr($line,$i,1),' ')==0) && ($vkh%2)):
				$c=chr(1);
			endif;
			$line2.=$c;
		endfor;
		$msv = split(' ',$line2);
		for ($i=0;$i<sizeof($msv);$i++) { $msv[$i] = str_replace(chr(1),' ',$msv[$i]); }
		$this->Status = array_shift($msv);
		$this->EchoTag = array_shift($msv);
		$this->Path = array_shift($msv);
		for ($i=0;$i<sizeof($msv); $i++)
		{
			if (strcmp(substr($msv[$i],0,1),'-')==0):
				$this->Options[$msv[$i]] = $msv[$i+1];
				$i++;
			else:
				$this->Links[] = $msv[$i];
			endif;
		}
	endif;
	}

	function AppendArea($fname)
	{
		tolog('Q',"Appending area {$this->EchoTag} to $fname");
		$line = $this->Status.' '.$this->EchoTag.' '.$this->Path;
		if ($this->Options):
		while (list($key,$value) = each($this->Options)):
			$line.=' '.$key.' '.$value;
		endwhile;
		endif;
		if ($this->Links):
		foreach ($this->Links as $item):
			$line.=" $item";
		endforeach;
		endif;
		$file = fopen($fname,'a') or die("Could not open file $fname");
		fwrite($file,"$line\n");
		fclose($file);
		return $line;
	}
}

class C_Areas
{
	var $Vals;
	var $Groups;

	function C_Areas($filename)
	{
		$file = fopen($filename,'r') or die ("Could not open file $filename");
		while ($line = fgets($file,10240))
		{
			$line=trim(strcmp(substr($line,0,1),'#')==0?'':strtok($line,'#'));
			if ($line)
			{
			if (strcasecmp(strtok($line,' '),'echogroup')==0):
				list($status,$name,$descr) = split(' ',$line,3);
				$this->Groups[$name] = $descr;
			else:
				$this->Vals[] = new C_AreaDef($line);
			endif;
			}
		}
		fclose($file);
	}

	function AppendAreaToConf($line)
	{
		$this->Vals[] = new C_AreaDef($line);
	}
	
	function FindAreaNum($name)
	{
		if ($this->Vals):
		for ($i=0;$this->Vals[$i];$i++)
		{
			if (strcasecmp($this->Vals[$i]->EchoTag,$name)==0):
				return $i;
			endif;
		}
		endif;
		return -1;
	}
}

class C_CONFIG
{
	var $Addresses;
	var $Links;
	var $Route;
	var $Vars;
	var $Areas;
	var $FAreas;
	var $Replaces;
	
	function C_CONFIG($filename)
	{
		GLOBAL $temp_dir;
		$this->ReadCfgFile($filename);
		@$temp_dir = $this->Vars['tempdir'];
	}

	function ReadCfgFile($filename)
	{
		$file = fopen($filename,'r') or die("Could not read file $filename!");
		while ($line = fgets($file,10240))
		{
			$line=trim(strcmp(substr($line,0,1),'#')==0?'':strtok($line,'#'));
			if ($line)
			{
				list($key,$value) = split(' ',$line,2);
				$key = trim(strtolower($key));
				$value = trim($value);
				if (strcmp($key,'route')==0):
					$this->Route[]=$value;
				elseif (strcmp($key,'address')==0):
					$this->Addresses[]=$value;
				elseif (strcmp($key,'replacestr')==0):
					$this->Replaces[]=$value;
				elseif (strcmp($key,'includelinks')==0):
					$this->Links = new C_Links($value);
				elseif (strcmp($key,'includeareas')==0):
					$this->Areas = new C_Areas($value);
				elseif (strcmp($key,'includefareas')==0):
					$this->FAreas = new C_Areas($value);
#				elseif (strcmp($key,'includeusers')==0):
#					$this->Users = new C_Users($value);
				elseif (strcmp($key,'include')==0):
					$this->ReadCfgFile($value);
				else:
					$i = '';
					while (@$this->Vars[$key.$i]) $i++;
					$this->Vars[$key.$i] = $value;
				endif;
			}
		}
		fclose($file);
	}

	function GetArray($param)
	{
		$cnt = '';
		$result = array();
		while(@$this->Vars[$param.$cnt]):
			$result[]=$this->Vars[$param.$cnt];
			$cnt++;
		endwhile;
		return $result;
	}
}

class C_LOG
{
	var $file;
	var $lvls;
	var $stdout;
	var $filename;

	function C_LOG($fname,$lvls)
	{
		GLOBAL $PROGRAM;
		$this->stdout = (strcasecmp($fname,'stdout')==0);
		$this->lvls = $lvls;
		$this->filename = $fname;
		if (!$this->stdout && (!$this->file = fopen($fname,'a')))
			{ die("Open log file \"$fname\" failed!"); }

			$Time=date("r");
			$this->write('1'," *** Started: $Time ({$PROGRAM[0]}/{$PROGRAM[1]})");
	}
	
	function write($lvl,$message)
	{
		if (strpos($this->lvls,$lvl)||(strcmp($lvl,substr($this->lvls,0,1))==0)):
		$date = date("d M, H:i:s");
		if ($this->stdout):
			print("$lvl $date $message\n");
		else:
			fwrite($this->file,"$lvl $date $message\n");
		endif;	
		endif;
	}

	function done()
	{
		$Time=date("r, t");
		$this->write('1'," *** End: $Time");
		if (!$this->stdout) { 
			fclose($this->file); 
			chmod($this->filename,0666);
		}
	}

	function refseek()
	{
		if (!$this->stdout):
		fseek($this->file,0,SEEK_END);
		endif;
	}
}

function initlog()
{
GLOBAL $CONFIG;
GLOBAL $LOGS;
if ($arr = $CONFIG->GetArray('logfile')):
foreach ($arr as $logfile):
list($fname,$lvls) = split(' ',$logfile);
$LOGS[] = new C_LOG($fname,$lvls);
endforeach;
endif;
}

function tolog($lvl,$message)
{
GLOBAL $LOGS;
for ($i=0;$i<sizeof($LOGS);$i++):
$LOGS[$i]->write($lvl,$message);
endfor;
}

function donelog()
{
GLOBAL $LOGS;
for($i=0;$i<sizeof($LOGS);$i++) { $LOGS[$i]->done(); }
$LOGS = array();
}

function refseeklog()
{
GLOBAL $LOGS;
for($i=0;$i<sizeof($LOGS);$i++) { $LOGS[$i]->refseek(); }
}

?>
