<?

require "C_mail.php";

function Receive_mail()
{
	GLOBAL $CONFIG;
	foreach($CONFIG->GetArray('pop3server') as $popsrv):
		Receive_mail_from($popsrv);
	endforeach;
}

function Receive_mail_from($popsrv)
{
	$error = 0;
	list($id,$hostport,$login) = split(' ',$popsrv);
	tolog('1',"Receiving mail from $id");
	list($host,$port) = split(':',$hostport);
	tolog('1',"Connecting with $host:$port");
	if (!$port) $port = 110;
	list($user,$pass) = split(':',$login);
	$pop = new C_pop3;
	if ($pop->Connect($host,$port)):
	if ($pop->Login($user,$pass)):
		$stats = $pop->Stat();
		for ($i=1;$i<=$stats[0];$i++):
		if (!Process_message($pop->GetMessage($i))):
		$error = 1;
		break;
		endif;
		endfor;
		$pop->Quit();
		tolog('1',$error?"Error during the session":"Session completed");
	else:
		$pop->Quit();
		tolog('1',"Access denied");
	endif;
	else:
		tolog('1',"Cannot connect $host:$port");
	endif;
}

function Process_message($message)
{
GLOBAL $CONFIG;
if ($tempin = $CONFIG->Vars['tempinbound']):
$i = 0;
while (file_exists($fname = $tempin."/msg".$i.'.ema')) $i++;
if ($f = fopen($fname,'w')):
fwrite($f,$message);
fclose($f);
return 1;
else:
tolog('1',"Error opening file $fname");
endif;
return 0;
else:
tolog('1',"Error: tempinbound not defined in config");
return 0;
endif;
}

function Send_mail()
{
GLOBAL $CONFIG;
GLOBAL $Outbound;

$polls = array();
$nodes = $Outbound->GetLinks();
if ($nodes):
	foreach ($nodes as $link)
	{
	if ($Outbound->GetMailTo($link)):
		if ($emailid = @$CONFIG->Links->Vals[$link]['sendvia']):
			@$polls[$emailid][] = $link;
		else:
			tolog('l',"$link is not email link");
		endif;
	endif;
	}
else:
	tolog('l','No outbound mail for EON\'s');
endif;

while(list($id,$links) = each($polls)):
	foreach($CONFIG->GetArray('smtpserver') as $smtp_rec):
		list($smtpid,$host_port,$user_pass) = split(' ',$smtp_rec);
		if (strcasecmp($id,$smtpid)==0):
			list($host,$port) = split(':',$host_port);
			list($user,$pass) = split(':',$user_pass);
			Send_mail_via($host,$port,$user,$pass,$links);
		endif;
	endforeach;
endwhile;
}

function Send_mail_via($host,$port,$user,$pass,$links)
{
	GLOBAL $Outbound;
	GLOBAL $CONFIG;
	if (!$port) $port = 25;
	tolog('C',"Connecting to $host:$port");
	$smtp = new C_smtp;
	$error = 0;
	if ($smtp->Connect($host,$port)):
	if ((strcmp($user,'-')==0) || ($smtp->Login($user,$pass))):
		foreach($links as $link):
			tolog('S',"Send mail for $link");
			foreach($Outbound->GetMailTo($link) as $file):
				$from = $CONFIG->Links->Vals[$link]['sendfrom'];
				$to = $CONFIG->Links->Vals[$link]['sendto'];
				$subj = $CONFIG->Links->Vals[$link]['sendsubj'];
				$as_file = (preg_match('/[0-9a-f]{8}\.(o|h|d|i|c)ut$/i',$file))?rand(10000000,99999999).'.pkt':basename($file);
				$message = File_to_email_msg($file,$as_file,$from,$to,$subj);
				if (!$smtp->helo($host)) { $error = 1; break 2; };
				if (!$smtp->rset()) { $error = 1; break 2; };
				if (!$smtp->SendMessage($message,$from,$to)) { $error = 1; break 2; };
				tolog('f',"Sent file $file as $as_file");
				$Outbound->DeleteSnt($link,basename($file));
			endforeach;
		endforeach;
		if (!$smtp->rset()) $error = 1;
		$smtp->Quit();
		tolog('1',$error?"Error during the session":"Session completed");
	else:
		$smtp->Quit();
		tolog('1',"Access denied");
	endif;
	else:
		tolog('1',"Cannot connect $host:$port");
	endif;
}

function File_to_email_msg($file,$as_file,$from,$to,$subj)
{
GLOBAL $PROGRAM;
$boundid = "==_".uniqid(time())."_==";
$result = "Mailer: {$PROGRAM[0]}/{$PROGRAM[1]}\r\n";
$result.= "To: $to\r\n";
$result.= "From: $from\r\n";
$result.= "Subject: $subj\r\n";
$result.= "Content-Type: multipart/mixed; boundary=\"$boundid\"\r\n";
$result.= "\r\n";
$result.= "--$boundid\r\n";
$result.= "Content-Type: application/octet-stream; name=\"$as_file\"\r\n";
$result.= "Content-Disposition: attachment; filename=\"$as_file\"\r\n";
$result.= "Content-Transfer-Encoding: base64\r\n";
$result.= "\r\n";
$base64 = base64_encode(file_get_contents($file));
while (strlen($base64) > 60):
$data = substr($base64,0,60);
$base64 = substr($base64,60);
$result.= $data."\r\n";
endwhile;
$result.= $base64."\r\n\r\r";
$result.= "--$boundid";
return $result;
}

function ExtractFile($f,$fname,$sec)
{
GLOBAL $CONFIG;
$b64 = '';
while (chop(fgets($f,10240)));
while ($line = fgets($f,10240)):
if (strcmp(substr($line,0,2),'--')==0):
break;
else:
$b64.= $line;
endif;
endwhile;
if ($fname):
$i='';
$path = ($sec?$CONFIG->Vars['inbound']:$CONFIG->Vars['unsecinbound']);
while (file_exists($fname2 = $path.'/'.$fname.$i)) $i++;
if ($file = fopen($fname2,'w')):
fwrite($file,base64_decode($b64));
fclose($file);
chmod($fname2,0666);
else:
die('Could not open file '.$fname2);
endif;
endif;
}

function ChkFields($from,$to,$subj)
{
GLOBAL $CONFIG;
reset($CONFIG->Links->Vals);
while(list($aka,$link) = each($CONFIG->Links->Vals)):
	$fromf = @trim($link['fieldfrom']);
	$tof = @trim($link['fieldto']);
	$subjf = @trim($link['fieldsubj']);
	if ($fromf || $tof || $subjf):
		if ((!$fromf || strstr($from,$fromf)) &&
		    (!$tof   || strstr($to,  $tof  )) &&
		    (!$subjf || strstr($subj,$subjf))):
		tolog('1','Bundle from '.$link['sysop']);
		return 1;
		endif;
	endif;
endwhile;
tolog('1','Unsecure bundle');
return 0;
}

function ExtractImi($fname)
{
GLOBAL $CONFIG;
$f = fopen($fname,'r');
$sec = 0;
$fn = '';
$subj = '';
$from = '';
$to = '';
while ($line = fgets($f,10240)):
@list($str,$val) = split(': ',chop($line));
$str."\n";
if (!$subj && (strcasecmp($str,'subject')==0)):
 $subj = $val;
elseif (!$from && (strcasecmp($str,'from')==0)):
 $from = $val;
elseif (!$to && (strcasecmp($str,'to')==0)):
 $to = $val;
elseif (preg_match('/Content-type:.*name\=\"(.*)\"/i',$line,$msv)):
	if (ChkFields($from,$to,$subj)) $sec = 1; else $sec = 0;
	$fn = $msv[1];
	ExtractFile($f,$fn,$sec);
endif;
endwhile;
fclose($f);
if ($sec) { unlink($fname); }
else { if ($bcp = $CONFIG->Vars['bcpdir']) 
{ 
	$i = 0;
	$fnb = basename($fname);
	while (file_exists($fn = $bcp.'/msg'.$i.'.ema')) $i++;
	rename($fname,$fn); 
} 
else { unlink($fname); }; }
}

function ExtractFiles()
{
GLOBAL $CONFIG;
if ($tmpin = $CONFIG->Vars['tempinbound']):
$dir = opendir($tmpin);
while($file = readdir($dir)):
if (preg_match('/msg[0-9]+\.ema/i',$file)):
ExtractImi($tmpin.'/'.$file);
endif;
endwhile;
closedir($dir);
endif;
}

Receive_mail();
ExtractFiles();
Send_mail();

?>
