<?

class C_pop3
{
	var $socket;
	var $request;
	var $answer;

	function Connect($host,$port)
	{
		if ($this->socket = @fsockopen($host,$port)):
			if (!$this->_sendstr()):
				fclose($this->socket);
				return 0;
			else:
				return 1;
			endif;
		endif;
		return 0;
	}

	function Login($user,$pass)
	{
		if (!$this->_sendstr("USER $user")) return 0;
		if (!$this->_sendstr("PASS $pass")) return 0;
		return 1;
	}

	function Stat()
	{
		if ($this->_sendstr('STAT')):
			list($ans,$num,$sz) = split(' ',$this->answer);
			return array($num,$sz);
		else:
			return '';
		endif;
	}

	function _disconnect()
	{
		fclose($this->socket);
	}

	function GetMessage($msg)
	{
		if ($this->_sendstr("RETR $msg")):
			$line = '';
			$result = '';
			while(strcmp(chop($line),'.')!=0):
			$result.=$line;
			$line = fgets($this->socket,10240);
			endwhile;
			$this->_sendstr("DELE $msg");
			return $result;
		else:
		return '';
		endif;
	}
	
	function Quit()
	{
		$this->_sendstr("QUIT");
		$this->_disconnect();
	}

	function _sendstr($str='')
	{
		$this->request = $str;
		if (strcmp($str,'')):
			tolog('X',"S: $str");
			fputs($this->socket,$str."\r\n");
		endif;
		$line = fgets($this->socket,10240);
		$this->answer = $line;
		tolog('X','R: '.chop($line));
		return strcmp(substr($line,0,3),'+OK')==0;
	}
}

class C_smtp
{
	var $socket;
	var $request;
	var $answer;

	function Connect($host,$port)
	{
		if ($this->socket = @fsockopen($host,$port)):
			if ($this->_sendstr()!=220):
				fclose($this->socket);
				return 0;
			else:
				return 1;
			endif;
		endif;
		return 0;
	}

	function Login($user,$pass)
	{
		if ($this->_sendstr("AUTH LOGIN")!=334) return 0;
		if ($this->_sendstr(base64_encode($user))!=334) return 0;
		if ($this->_sendstr(base64_encode($pass))!=235) return 0;
		return 1;
	}

	function Rset()
	{
		return ($this->_sendstr("RSET")==250?1:0);
	}

	function Helo($host)
	{
		return ($this->_sendstr("HELO $host")==250?1:0);
	}
/*
	function Stat()
	{
		if ($this->_sendstr('STAT')):
			list($ans,$num,$sz) = split(' ',$this->answer);
			return array($num,$sz);
		else:
			return '';
		endif;
	}
*/
	function _disconnect()
	{
		fclose($this->socket);
	}

	function SendMessage($msg,$from,$to)
	{
		$msg = str_replace("\r","",$msg);
		$msg = str_replace("\n.\n","\n. \n",$msg);
		$msg = str_replace("\n","\r\n",$msg);
		if (($this->_sendstr("MAIL FROM:<$from>")==250) &&
		    ($this->_sendstr("RCPT TO:<$to>")==250) &&
		    ($this->_sendstr("DATA")==354)):
			fputs($this->socket,$msg."\r\n.\r\n");
			return $this->_sendstr()==250;
		else:
		return 0;
		endif;
	}

	function Quit()
	{
		$this->_sendstr("QUIT");
		$this->_disconnect();
	}

	function _sendstr($str='')
	{
		$this->answer = '';
		$this->request = $str;
		if (strcmp($str,'')):
			tolog('X',"S: $str");
			fputs($this->socket,$str."\r\n");
		endif;
		do {
		$line = fgets($this->socket,10240);
		$this->answer.=$line;
		tolog('X','R: '.chop($line));
		$ps = strpos($line,' ');
		} while (($ps>3)||($ps<2));
		return (int)strtok($line,' ');
	}
}

?>
